Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* aisa57w.bas                                                               *
'*                                                                           *
'* aPCI-A57                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/08/03                                                           *
'*                                                                           *
'*****************************************************************************
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA57_DLL_NAME = "aisa57.dll" ' DLL

Dim hDLL As Long                'DLLւ̃nh

Global Const AISA57_ERR_WRAPDLL = -1  ' bp[֐G[

'*****************************************************************************
'*    aisa57.dll[h                                                 *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa57wDllOpen() As Boolean

    Aisa57wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(AISA57_DLL_NAME)
    If hDLL = 0 Then Exit Function

    If Aisa57wGetDllExportFunc() = False Then
        Aisa57wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If

    Aisa57wDllOpen = True

End Function

'*****************************************************************************
'*    aisa57.dllA[h                                             *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa57wDllClose() As Boolean

    Aisa57wDllClose = True

    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Aisa57wDllClose = False

End Function

'*****************************************************************************
'*    aPCI-A57 DLL,Driver̃o[Wԍ擾                            *
'*    pdwDllVer DLLo[Wԍi[                                  *
'*        pdwDrvVer Drivero[Wԍi[                               *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa57wGetVersion(ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Boolean

    Aisa57wGetVersion = False

    If hDLL = 0 Then Exit Function

    If Aisa57GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function

    Aisa57wGetVersion = True

End Function

'*****************************************************************************
'*    aPCI-A57̔Cӂ̃foCX̎gp錾                               *
'*    pwLogSlot gpfoCXi[AhX                       *
'*        hWnd      bZ[W𑗂EBhEnh                       *
'*        uWMBase   ƂȂ郁bZ[WID                                   *
'*        pvInitArg gp(0Zbg)                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa57wCreate(ByRef pwLogSlot As Integer, ByVal hWnd As Long, ByVal uWMBase As Long, ByRef pvInitArg As Long) As Boolean

    Aisa57wCreate = False

    If hDLL = 0 Then Exit Function

    If Aisa57Create(pwLogSlot, hWnd, uWMBase, pvInitArg) = 0 Then Exit Function

    Aisa57wCreate = True

End Function

'*****************************************************************************
'*    aPCI-A57̔Cӂ̃foCX̎gpJ                               *
'*    wLogSlot gpfoCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa57wClose(ByVal wLogSlot As Integer) As Boolean

    Aisa57wClose = False

    If hDLL = 0 Then Exit Function

    If Aisa57Close(wLogSlot) = 0 Then Exit Function

    Aisa57wClose = True

End Function

'*****************************************************************************
'*    wfoCX̃\[X擾                                   *
'*    wLogSlot ׂfoCX                                            *
'*        pres     \[Xi[\                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa57wGetResource(ByVal wLogSlot As Integer, ByRef pres As AISA57RESOURCE) As Boolean

    Aisa57wGetResource = False

    If hDLL = 0 Then Exit Function

    If Aisa57GetResource(wLogSlot, pres) = 0 Then Exit Function

    Aisa57wGetResource = True

End Function

'*****************************************************************************
'*    TvO[h̐ݒ                                           *
'*    wLogSlot ݒ肷foCX                                          *
'*        pcmode   [hݒf[^̃AhX                                *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa57wSetMode(ByVal wLogSlot As Integer, ByRef pcmode As AISA57MODE) As Boolean

    Aisa57wSetMode = False

    If hDLL = 0 Then Exit Function

    If Aisa57SetMode(wLogSlot, pcmode) = 0 Then Exit Function

    Aisa57wSetMode = True

End Function

'*****************************************************************************
'*    TvOJn                                                   *
'*    wLogSlot JnfoCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa57wStartSampling(ByVal wLogSlot As Integer) As Boolean

    Aisa57wStartSampling = False

    If hDLL = 0 Then Exit Function

    If Aisa57StartSampling(wLogSlot) = 0 Then Exit Function

    Aisa57wStartSampling = True

End Function

'*****************************************************************************
'*    TvO~                                                   *
'*    wLogSlot ~foCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa57wStopSampling(ByVal wLogSlot As Integer) As Boolean

    Aisa57wStopSampling = False

    If hDLL = 0 Then Exit Function

    If Aisa57StopSampling(wLogSlot) = 0 Then Exit Function

    Aisa57wStopSampling = True

End Function

'*****************************************************************************
'*    TvOEXe[^X̎擾                                     *
'*    wLogSlot   擾foCX                                        *
'*        pcwNumData f[^obt@                                        *
'*        pdwStatus  Xe[^X                                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa57wGetSamplingStatus(ByVal wLogSlot As Integer, ByRef pcwNumData As Long, ByRef pdwStatus As Long) As Boolean

    Aisa57wGetSamplingStatus = False

    If hDLL = 0 Then Exit Function

    If Aisa57GetSamplingStatus(wLogSlot, pcwNumData, pdwStatus) = 0 Then Exit Function

    Aisa57wGetSamplingStatus = True

End Function

'*****************************************************************************
'*    TvOς݃f[^̎擾                                       *
'*    wLogSlot  擾foCX                                         *
'*        cwNumData vf[^                                             *
'*        pwData    f[^obt@                                           *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa57wGetData(ByVal wLogSlot As Integer, ByVal cwNumData As Long, ByRef pwData() As Integer) As Boolean

    Aisa57wGetData = False

    If hDLL = 0 Then Exit Function

    If Aisa57GetData(wLogSlot, cwNumData, pwData(LBound(pwData))) = 0 Then Exit Function

    Aisa57wGetData = True

End Function

'*****************************************************************************
'*    D/Af[^̏o                                                    *
'*    wLogSlot  o͂foCX                                         *
'*        wChData   ݃`lw                                   *
'*        wDaData   o͂D/Af[^                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa57wSetData(ByVal wLogSlot As Integer, ByVal wChData As Integer, ByVal wDaData As Integer) As Boolean
    
    Aisa57wSetData = False
    
    If hDLL = 0 Then Exit Function

    If Aisa57SetData(wLogSlot, wChData, wDaData) = 0 Then Exit Function

    Aisa57wSetData = True

End Function

'*****************************************************************************
'*    Cӂ̃|[gf[^                                       *
'*    wLogSlot  ͂foCX                                         *
'*        pbInValue ̓f[^i[AhX                             *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa57wInPort(ByVal wLogSlot As Integer, ByRef pbInValue As Byte) As Boolean

    Aisa57wInPort = False
    
    If hDLL = 0 Then Exit Function

    If Aisa57InPort(wLogSlot, pbInValue) = 0 Then Exit Function

    Aisa57wInPort = True

End Function

'*****************************************************************************
'*    Cӂ̃|[gփf[^o                                         *
'*    wLogSlot  o͂foCX                                         *
'*        bOutValue o͂f[^                                           *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa57wOutPort(ByVal wLogSlot As Integer, ByVal bOutValue As Byte) As Boolean

    Aisa57wOutPort = False
    
    If hDLL = 0 Then Exit Function

    If Aisa57OutPort(wLogSlot, bOutValue) = 0 Then Exit Function

    Aisa57wOutPort = True

End Function

'*****************************************************************************
'*    aPCI-A57̃G[R[h                                             *
'*    wLogSlot  G[foCX                                 *
'* ߂l G[R[h                                                       *
'*****************************************************************************
Function Aisa57wGetLastError(ByVal wLogSlot As Integer) As Long

    Aisa57wGetLastError = AISA57_ERR_WRAPDLL

    If hDLL = 0 Then Exit Function

    Aisa57wGetLastError = Aisa57GetLastError(wLogSlot)

End Function

'*---------------------------------------------------------------------------*
'*    DLLGNX|[g֐L̊mF                                      *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*---------------------------------------------------------------------------*
Private Function Aisa57wGetDllExportFunc() As Boolean

    Dim pFunc As Long

    Aisa57wGetDllExportFunc = False

    ' Aisa57GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa57GetVersion")
    If pFunc = 0 Then Exit Function

    ' Aisa57Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa57Create")
    If pFunc = 0 Then Exit Function

    ' Aisa57Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa57Close")
    If pFunc = 0 Then Exit Function

    ' Aisa57GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa57GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa57SetMode ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa57SetMode")
    If pFunc = 0 Then Exit Function

    ' Aisa57StartSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa57StartSampling")
    If pFunc = 0 Then Exit Function

    ' Aisa57StopSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa57StopSampling")
    If pFunc = 0 Then Exit Function

    ' Aisa57GetSamplingStatus ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa57GetSamplingStatus")
    If pFunc = 0 Then Exit Function

    ' Aisa57GetData ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa57GetData")
    If pFunc = 0 Then Exit Function

    ' Aisa57SetData ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa57SetData")
    If pFunc = 0 Then Exit Function

    ' Aisa57InPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa57InPort")
    If pFunc = 0 Then Exit Function

    ' Aisa57OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa57OutPort")
    If pFunc = 0 Then Exit Function

    ' Aisa57GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa57GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa57wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
